package cn.iocoder.yudao.module.pms.service.failure;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.module.pms.controller.admin.failure.vo.IotFailureReportPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.failure.vo.IotFailureReportProcessVO;
import cn.iocoder.yudao.module.pms.controller.admin.failure.vo.IotFailureReportSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.failure.IotFailureReportDO;
import cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO;

/**
 * 故障上报 Service 接口
 *
 * @author 芋道源码
 */
public interface IotFailureReportService {
    void approvalFailureReport(Long id, Integer bpmResult);
    /**
     * 提交供应商数据审核
     *
     */
    String submitForApproval(Long id);
    /**
     * 创建故障上报
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIotFailureReport(@Valid IotFailureReportSaveReqVO createReqVO);
    Long updateIotFailureReportProcess(IotFailureReportProcessVO processVO);
    /**
     * 更新故障上报
     *
     * @param updateReqVO 更新信息
     */
    void updateIotFailureReport(@Valid IotFailureReportSaveReqVO updateReqVO);

    /**
     * 删除故障上报
     *
     * @param id 编号
     */
    void deleteIotFailureReport(Long id);

    /**
     * 获得故障上报
     *
     * @param id 编号
     * @return 故障上报
     */
    IotFailureReportDO getIotFailureReport(Long id);
    List<AdminUserRespDTO> getApproval();

    /**
     * 获得故障上报分页
     *
     * @param pageReqVO 分页查询
     * @return 故障上报分页
     */
    PageResult<IotFailureReportDO> getIotFailureReportPage(IotFailureReportPageReqVO pageReqVO);
    PageResult<IotFailureReportDO> getIotFailureReportPageApp(IotFailureReportPageReqVO pageReqVO);

    /**
     * 调拨后同步 维修 保养 巡检 工单历史数据
     * @param deviceIds 设备id集合
     * @param deptId 调拨后的部门id
     */
    void syncWordOrderData(List<Long> deviceIds, Long deptId);
}
